// program ct_sino
// 
// Required files are q???.tif, dark.tif.
// output file "s????.sin"

/*----------------------------------------------------------------------*/
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <time.h>
//#include <malloc.h>
#include "cell.h"
#include "ril.h"

/*----------------------------------------------------------------------*/
#ifndef M_PI
#define M_PI	3.14159265358979323846
#endif
#define INTEL
#define MAX_SHOT			20010
#define MAXPIXL				20901

/*----------------------------------------------------------------------*/

// main data for read transmitted images (data[y][x])
unsigned short	data[MAXPIXL];

//dark file name and data
unsigned short	dark[MAXPIXL];
short	cent_flag;

// image profile from 'output.log'
float	shottime[MAX_SHOT], shotangle[MAX_SHOT];
int		Ishot[MAX_SHOT], NST, NI0, II0[MAX_SHOT];

// parameters for interpolation of incident beam
unsigned short	II01[MAXPIXL], II02[MAXPIXL];     // II01[x], II02[x]
unsigned short	I[MAXPIXL];                                // I[x]
double	I0[MAXPIXL];

// file head character  q???.img or q????.img
char	flhead[]   = "q";
char	darkfile[] = "dark.tif";

// output file name
char	fn[15];

// flag for q001.img or q0001.img
int		iFlag;

// projection
//double	p[MAX_SHOT][MAXPIXL];
short	N, n_total;

// calculation layer
short	s_layer;

// total absorption
double	TA, TA1, TA2, TAM, TASD;

int		Nx, Ny;

double	*bbbb;


/*----------------------------------------------------------------------*/

static void Error(msg)
char        *msg;
{
	fputs(msg,stderr);
	fputc('\n',stderr);
	exit(1);
}



int	read_tiff_line(char *fname, unsigned short *data, short ln)
{
	Cell	*cell;
	int		iii;
//printf("tiff_line\t%s\t%d\tsta\n",fname, ln);

//	if (argc!=3 && argc!=5) Error("usage : tiff2line TIFF {x1 x2} y");

	ReadImageLine(fname,&Nx,&Ny,NULL,&cell,s_layer);
//	ReadImageLine(fname,&Nx,&Ny,NULL,NULL,0);
//	ReadImageLine(fname,NULL,NULL,NULL,&cell,s_layer);

	for (iii=0;iii<Nx;++iii){
		data[iii]=(unsigned short)cell[iii];
//		printf("%d\t%d\t%d\n", iii, data[iii], cell[iii]);
	}

	N=Nx;

	free(cell);
	return 0;
}

/*----------------------------------------------------------------------*/

int read_log()
{
	int			i, j, nnn;
	FILE		*f;
	char		line[100], *ss;
	int			flg_I0;
// open parameter file
	if((f = fopen("output.log","r")) == NULL){
		printf("cannot open output.log \n");
		return(-10);
	}

// read parameters
	NI0 = 0;
	NST = 0;
	nnn = 0;
	j   = 0;
	while(j>=0){
		j=j+1;
		line[0]='\0';
		ss = fgets(line, 100, f);
		if (i = strlen(line) > 2){
			sscanf(line, "%d %f %f %d", &nnn, &shottime[j], &shotangle[j], &flg_I0);
			if (flg_I0 == 0){
				II0[NI0] = nnn;
				NI0 = NI0 + 1;				// I_0  shot 
			}
			else{
				Ishot[NST] = nnn;
				NST = NST + 1;				// I  shot 
			}
		}
		else{
			break;
		}
	}
	n_total = nnn + 2;
	fprintf(stderr, " nshot = %d, NI0 = %d, total = %d \n", NST, NI0, n_total);
	fclose(f);
	if(n_total<1000) iFlag = 0;
	if(n_total>=1000) iFlag = 1;
	if(n_total>MAX_SHOT){
		fprintf(stderr, "Too many projections!");
		return(1);
	}
	return(0);
}

/*----------------------------------------------------------------------*/

static int StoreProjection(ln)
short		ln;
{
	int			i, j, k, jx, nshot, *ilp, iplc;
	double		t1, t2;
	double		a[MAXPIXL], b[MAXPIXL];
	char		ffi01[15], ffi02[15], fii[15];
	double		I01, I02;

	double		*po, *poa;
	double		p_sum,p_ave;
	FILE		*fi;

// p initialization
	po = (double *)malloc(N*NST*sizeof(double));

	TA1 =0.0;
	TA2 =0.0;

	ilp=(int *)malloc(NST*sizeof(int));
	iplc=0;

	poa = (double *)malloc(N*sizeof(double));
	for(j=0;j<N;++j) *(poa+j)=0.0;

// ߑ̐JEgB(ŏIIɂ NST = nshot ɂȂ͂)
	nshot = 0;

// I_0  I_0 ɋ܂ꂽߑ荞ރ[v
	for ( j = 0; j < NI0-1; ++j){

//IIO[j] and IIO[j+1]  open 
		if(iFlag==0) sprintf(ffi01, "%s%03d.tif", flhead, II0[j]);
		if(iFlag==1) sprintf(ffi01, "%s%04d.tif", flhead, II0[j]);
		if ((i = read_tiff_line(ffi01, &II01[0], ln)) != 0){
			printf("something wrong -- return value is %d(II01)", i);
			exit(-1);
		}
//	for(i=0;i<4000;++i) printf("%d\t%d\t%s\n",i,II01[i],ffi01);
		if(iFlag==0) sprintf(ffi02, "%s%03d.tif", flhead, II0[j+1]);
		if(iFlag==1) sprintf(ffi02, "%s%04d.tif", flhead, II0[j+1]);
		if ((i = read_tiff_line(ffi02, &II02[0], ln)) != 0){
			printf("something wrong -- return value is %d(II02)", i);
			exit(-1);
		}
//	for(i=0;i<4000;++i) printf("%d\t%d\t%s\n",i,II01[i],ffi02);
// I0EV ̌W߂邽߂̏
		t1 = shottime[II0[j]];
		t2 = shottime[II0[j+1]];

// 1 layer(ln) I_0̒l}
		for (jx = 0; jx < N; ++jx){
			I01   = (double)II01[jx]-dark[jx]; // OI_0ňꎟ
			I02   = (double)II02[jx]-dark[jx];
			a[jx] = (double)(((double)(I02   - I01))    / (t2 - t1));      //ԌW߂
			b[jx] = (double)(((double)I01*t2 - (double)I02*t1) / (t2 - t1));
		}
		for ( k = II0[j] + 1; k < II0[j+1]; ++k){
// a[jx], b[jx]  shottime[k] p p(x) ߂B
			if(iFlag==0) sprintf(fii, "%s%03d.tif", flhead, k);
			if(iFlag==1) sprintf(fii, "%s%04d.tif", flhead, k);
			if ((i = read_tiff_line(fii, &I[0], ln)) != 0){
				printf("something wrong -- return value is %d(II01)", i);
				return(-1);
			}
//			printf("%s\t%d\n",fii,s_layer);
//for(i=0;i<4000;++i) printf("%d\t%d\t%s\t%d\n",i,I[i],fii,N);
			*(ilp+nshot)=0;
			for (jx = 0; jx < N; ++jx){
				I0[jx]    = a[jx] * shottime[k] + b[jx];
				if ((I[jx]-dark[jx]) < 0){
//					if(*(ilp+nshot)==0){
//						printf("Warning in %s\n", fii);
//						printf("  jx = %d, I0 = %f, I = %d, dark = %d, ln =%d \n", jx, I0[jx], I[jx], dark[jx], ln);
//						printf("  II01 = %d, II02 = %d\n", II01[jx], II02[jx]);
//						printf("  t1   = %f, t2   = %f \n", t1, t2);
//						printf("  data is negative!! = %f,  %d\n",(double)I0[jx] / (double)(I[jx]-dark[jx]), jx);
//						printf("  a = %f,  b = %f\n", a[jx], b[jx]);
//						//exit(-11);
//						*(ilp+nshot)=1;
//					}
					*(po+N*nshot+jx)= 0.0;
				}else{
					*(po+N*nshot+jx)= log((double)(I0[jx])/(double)(I[jx]-dark[jx]));
				}
			}
//			if(*(ilp+nshot)==1){
//				for(jx=0;jx<N;++jx){
//					*(po+N*nshot+jx)=0.0;
//				}
//			}

			
			if(*(ilp+nshot)==0){
// roupe for correction
				p_sum = 0.0;
				p_ave = 0.0;
				for (jx=0; jx<10; ++jx){
					p_sum = p_sum + *(po+N*nshot+jx) + *(po+N*nshot+N-jx);
				}
				p_ave = p_sum / (10.-0.) / 2.;
				TA=0.0;
				for (jx=0; jx<N; ++jx){
//					*(po+N*nshot+jx) = *(po+N*nshot+jx) - p_ave; /* comment out here */
					TA = TA + *(po+N*nshot+jx);
					*(poa+jx)=*(poa+jx)+*(po+N*nshot+jx);
				}
				TA1=TA1+TA;
				TA2=TA2+TA*TA;
				iplc=iplc+1;
			}


			nshot = nshot + 1;
			if((nshot%100)==0) printf("%d\r",nshot);
		} // end of k loop
	}     // end of j loop

// correcion for black projection
//	for(k=0;k<NST;++k){
//		if(*(ilp+k)==1){
//			printf("%d\t%d\n",k,*(ilp+k) );
//			for(j=0;j<N;++j){
//				 p[k][j]=*(poa+j)/(double)iplc;
//			}
//		}
//	}

//open output files
	sprintf(fn,"s%04d.sin", ln);
	if((fi = fopen(fn,"wb")) == NULL){ 
		printf("can not open %s for input\n", fn);
		return(-10);
	}

// write sinogram image to file
	if(i=fwrite(po,sizeof(double),N*NST,fi)>N*NST*sizeof(double)){
		fprintf(stderr, " Error writing data to %s at %d\n", fn, i);
		fclose(fi);
		return(i+1);
	}
	fclose(fi);

	return (0);
}

float calc_center(){
int		i;
long	j, dx, dx0, N1;
double	mm1, mx1, mm2, mx2;
double	*p000, *p180, rsum, rd, rmsd0, rmsd;
float	center;

// file name and data for calculation of rotation center (data[y][x])
// odd = I_0, even = transmitted
char	c_file[13];
unsigned short	cent_1[MAXPIXL], cent_2[MAXPIXL];
unsigned short	cent_3[MAXPIXL], cent_4[MAXPIXL];

// read center file
//I_0 file
	if(iFlag==0) sprintf(c_file, "%s001.tif", flhead);
	if(iFlag==1) sprintf(c_file, "%s0001.tif", flhead);
	if ((i = read_tiff_line(c_file, &cent_1[0], s_layer)) != 0){
		printf("something wrong -- return value is %d", i);
		exit(-1);
	}
// zero degree file(transmitted)
	if(iFlag==0) sprintf(c_file, "%s002.tif", flhead);
	if(iFlag==1) sprintf(c_file, "%s0002.tif", flhead);
	if ((i = read_tiff_line(c_file, &cent_2[0], s_layer)) != 0){
		printf("something wrong -- return value is %d", i);
		exit(-1);
	}
//I_0 file
	if(iFlag==0) sprintf(c_file, "%s%03d.tif", flhead, n_total-1);
	if(iFlag==1) sprintf(c_file, "%s%04d.tif", flhead, n_total-1);
	if ((i = read_tiff_line(c_file, &cent_3[0], s_layer)) != 0){
		printf("something wrong -- return value is %d", i);
		exit(-1);
	}
//  180 degree file(transmitted)
	if(iFlag==0) sprintf(c_file, "%s%03d.tif", flhead, n_total);
	if(iFlag==1) sprintf(c_file, "%s%04d.tif", flhead, n_total);
	if ((i = read_tiff_line(c_file, &cent_4[0], s_layer)) != 0){
		printf("something wrong -- return value is %d", i);
		exit(-1);
	}

	center = 0.0;
// calculate center with RMSD
		p000=(double *)malloc(N*sizeof(double));
		p180=(double *)malloc(N*sizeof(double));
		for(j=0;j<N;++j){
			*(p000+j)=log((double)(cent_2[j]-dark[j]) / (double)(cent_1[j]-dark[j]));
			*(p180+j)=log((double)(cent_4[j]-dark[j]) / (double)(cent_3[j]-dark[j]));
		}
		
		N1=N-1;
		rsum=0.0;
		for(j=0;j<N;++j){
			rd=*(p000+j)-*(p180+N1-j);
			rsum=rsum+rd*rd;
		}
		rmsd0=sqrt(rsum/(double)N);
		dx0=0;

		for(dx=1;dx<=N/2;++dx){
			rsum=0.0;
			for(j=0;j<N1-dx;++j){
				rd=*(p000+dx+j)-*(p180+N1-j);
				rsum=rsum+rd*rd;
			}
			rmsd=sqrt(rsum/(double)(N-dx));
			if(rmsd0>rmsd){
				rmsd0=rmsd;
				dx0=dx;
//				printf("%d\t%lf\t%lf\n", dx,rmsd0,rmsd);
			}

			rsum=0.0;
			for(j=0;j<N1-dx;++j){
				rd=*(p000+j)-*(p180-dx+N1-j);
				rsum=rsum+rd*rd;
			}
			rmsd=sqrt(rsum/(double)(N-dx));
			if(rmsd0>rmsd){
				rmsd0=rmsd;
				dx0=-dx;
//				printf("%d\t%lf\t%lf\n", -dx,rmsd0,rmsd);
			}
		}
		center=(N1+dx0)/2.0;
//		printf("%d\t%lf\t%lf\n", dx0,rmsd0,center);

	return(center);
}


/*----------------------------------------------------------------------*/

#ifndef CLOCKS_PER_SEC
#define CLOCKS_PER_SEC	1000000
extern long clock();
#endif

#define CLOCK()		((double)clock()/(double)CLOCKS_PER_SEC)
#define DESC_LEN	256

int main(argc,argv)
int		argc;
char	**argv;
{
	double		Clock;					// timer setting
	int			i;
	FILE		*fo;

// parameter setting
	if (argc==4){
		sprintf(flhead,   "%s", argv[2]);
		sprintf(darkfile, "%s", argv[3]);
	}
	else if (argc==3){
		sprintf(flhead, "%s", argv[2]);
	}
	else if (argc==2){
	}
	else{
		fprintf(stderr, "parameter was wrong!!!\n");
		fprintf(stderr, "usage : sinogram layer (head) (dark)\n");
		fprintf(stderr, "default head=q, dark=dark.tif\n");
		return(1);
	}
	s_layer = atoi(argv[1]);

// read shot log file
	if ((i = read_log()) != 0){
		fprintf(stderr, "canot read 'output.log' ! (%d)\n", i);
		return(1);
	}

// read dark image
	if ((i = read_tiff_line(darkfile, &dark[0], s_layer)) != 0){
		fprintf(stderr, "something wrong in dark file (%d)\n", i);
		return(1);
	}

	cent_flag = 0;
	Clock=CLOCK();
	if((i=StoreProjection(s_layer)) !=0){
		printf("something wrong in StoreProjection (%d)\n",i);
		return(1);
	}
	TAM=TA1/NST;
	TASD=sqrt(TA2/NST-TAM*TAM);
	fprintf(stderr," TA mean\t%lf\tTASD\t%lf\n", TAM, TASD);
	fprintf(stderr," TASD/TA mean\t%lf\n", TASD/TAM);
	fprintf(stderr," Store Sinogram \t%lf / sec\n",CLOCK()-Clock);
//	fprintf(stderr, "output file name = %s \n", fn);

//open output files
	if((fo = fopen("sino.tmp","w")) == NULL){ 
		printf("can not open %s for input\n", fn);
		return(1);
	}
	fprintf(fo, "%d\n", Nx);
	fprintf(fo, "%d\n", NST);
	fprintf(fo, "%04d\n", s_layer);
	fprintf(fo, "%f\n", calc_center());
	fprintf(fo, "%lf\n", TAM); // Mean of Total Absorption from sinogram
	fprintf(fo, "%lf\n", TASD); // SD of Total Absorption from sinogram
	fclose(fo);

	return(0);
}
